module Planik
  module Arbeitszeitkonto

    ##
    # Ein Zeitkonto im Rhythmus :täglich
    ##
    class TaeglichZeitkontoCalculator < ZeitkontoCalculator

      ##
      #
      #
      def initialize zeit_von, zeit_bis
        @zeit_von = zeit_von
        @zeit_bis = zeit_bis
      end


      ##
      # Liefert
      # * Anzahl Sekunden, welche die gegebene :zeitspanne mit dem Zeitkonto überlappt
      # * Die Reste (Zeitspanne[n])
      ##
      def calculate zeitspannen
        reste = []
        seconds = 0
        Array(zeitspannen).each do |zeitspanne|
          zeitspanne_1 = Zeitspanne.relative(zeitspanne.datum - 1, @zeit_von, @zeit_bis)
          zeitspanne_2 = Zeitspanne.relative(zeitspanne.datum, @zeit_von, @zeit_bis)
          sec, r = calc(Array(zeitspanne), [zeitspanne_1, zeitspanne_2])
          seconds+=sec
          reste.push(*r)
        end
        [seconds, reste]
      end
    end
  end
end
