module Planik
  module Arbeitszeitkonto

  ##
  # Zulagen berechnen für Medphone
  ##
  class ZeitkontoCalculator

    protected


    ##
    # Erstellt ein neues Time Objekt mit Datum von @datum und dem Reste von @zeit
    ##
    def kombiniere(datum, zeit)
      zeit.change(year: datum.year, month: datum.month, day: datum.day)
    end

    ##
    # Hilfsfunktion, um die Zeiten für die Zulagen zu berechnen
    # liefert die Anzahl Sekunde der Überlappung(en) und den Rest als Zeitspanne zurück
    ##
    def calc zeitspannen, zeitspannen_des_zeitkontos
      sum_seconds = 0
      zeitspannen_des_zeitkontos.each do |zeitspanne_des_kontos|
        neue_zeitspannen = []
        zeitspannen.each do |zeitspanne|

          #puts "#{self.class.name}#calc: kandidat_zeitspanne   = #{zeitspanne.to_s}"
          #puts "#{self.class.name}#calc: zeitspanne_des_kontos = #{zeitspanne_des_kontos.to_s}"
          seconds, reste = zeitspanne_des_kontos.overlap(zeitspanne)
          neue_zeitspannen.push(*reste)
          sum_seconds += seconds
        end
        zeitspannen = neue_zeitspannen
      end
      #puts "#{self.class.name}#calc: Reste = #{zeitspannen.map(&:to_s).join(", ")}"
      [sum_seconds, zeitspannen]
    end
  end

end
end
